//+------------------------------------------------------------------+ 
//|                                                    Mikahekin.mq5 | 
//|                                                                  | 
//|                              Modified by: Ronald Verwer/ROVERCOM |
//+------------------------------------------------------------------+ 
#property copyright ""
#property link ""
//----   
#property version   "1.00"
//----     
#property indicator_chart_window 
//----    5
#property indicator_buffers 5 
//----    
#property indicator_plots   3
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----     
#property indicator_type1   DRAW_COLOR_HISTOGRAM2
//----     
#property indicator_color1 Gray,Red,Lime
//----   -  
#property indicator_style1  STYLE_SOLID
//----     5
#property indicator_width1  5
//----   
#property indicator_label1  "Signal"

//----     
#property indicator_type2   DRAW_ARROW
//----       
#property indicator_color2 Magenta
//----    1
#property indicator_width2  1
//----   
#property indicator_label2  "Buy StopLoss"

//----     
#property indicator_type3   DRAW_ARROW
//----       
#property indicator_color3 Blue
//----    1
#property indicator_width3  1
//----   
#property indicator_label3  "Sell StopLoss"

//+-----------------------------------+
//|         |
//+-----------------------------------+
input int KPeriod=3;
input int JPeriod=7;
//+-----------------------------------+
//----   ,    
//      
double UpperBuffer[];
double LowerBuffer[];
double OpMiddleBuffer[];
double ClMiddleBuffer[];
double ColorMiddleBuffer[];
//----   
int Count[];
double Highest[],Lowest[];
//----      
int min_rates_total;
//+------------------------------------------------------------------+
//|                       |
//+------------------------------------------------------------------+   
void Recount_ArrayZeroPos
(
 int &CoArr[]//        
 )
// Recount_ArrayZeroPos(count)
//+ - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -+
  {
//----
   int numb,Max1,Max2;
   static int count=1;

   Max2=MathMax(KPeriod,JPeriod);
   Max1=Max2-1;

   count--;
   if(count<0) count=Max1;

   for(int iii=0; iii<Max2; iii++)
     {
      numb=iii+count;
      if(numb>Max1) numb-=Max2;
      CoArr[iii]=numb;
     }
//----
  }
//+------------------------------------------------------------------+    
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----  
   min_rates_total=KPeriod+JPeriod;

//----       
   ArrayResize(Count,JPeriod);
   ArrayResize(Highest,JPeriod);
   ArrayResize(Lowest,JPeriod);

//----      
   SetIndexBuffer(0,OpMiddleBuffer,INDICATOR_CALCULATIONS);
//----       1
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(OpMiddleBuffer,true);

//----      
   SetIndexBuffer(1,ClMiddleBuffer,INDICATOR_CALCULATIONS);
//----       2
   PlotIndexSetInteger(1,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(ClMiddleBuffer,true);
   
//----     ,     
   SetIndexBuffer(2,ColorMiddleBuffer,INDICATOR_COLOR_INDEX);
//----      
   PlotIndexSetInteger(2,PLOT_DRAW_BEGIN,min_rates_total);
//----       
   ArraySetAsSeries(ColorMiddleBuffer,true);

//----      
   SetIndexBuffer(3,UpperBuffer,INDICATOR_DATA);
//----       3
   PlotIndexSetInteger(3,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(3,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(UpperBuffer,true);

//----      
   SetIndexBuffer(4,LowerBuffer,INDICATOR_DATA);
//----       4
   PlotIndexSetInteger(4,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(4,PLOT_EMPTY_VALUE,EMPTY_VALUE);
//----       
   ArraySetAsSeries(LowerBuffer,true);

//----      
   string shortname;
   StringConcatenate(shortname,"Mikahekin( ",KPeriod,", ",JPeriod," )");
//---           
   IndicatorSetString(INDICATOR_SHORTNAME,shortname);
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits+1);
//----  
  }
//+------------------------------------------------------------------+  
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+  
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(rates_total<min_rates_total) return(0);

//----       
   double sumlow,sumhigh,sumopen,sumclose,Max,Min,Op,Cl;
//----   
   int limit,bar;

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
        limit=rates_total-KPeriod-1; //      
   else limit=rates_total-prev_calculated;  //       
     
//----         
   ArraySetAsSeries(high,true);
   ArraySetAsSeries(low,true);
   ArraySetAsSeries(open,true);
   ArraySetAsSeries(close,true);

//----      
   for(bar=limit; bar>=0; bar--)
     {
      Highest[Count[0]]=high[ArrayMaximum(high,bar,KPeriod)];
      Lowest [Count[0]]=low [ArrayMinimum(low, bar,KPeriod)];

      if(bar>rates_total-min_rates_total-1)
        {
         Recount_ArrayZeroPos(Count);
         continue;
        }

      sumlow=0.0;
      sumhigh=0.0;
      sumopen=0.0;
      sumclose=0.0;

      for(int kkk=0; kkk<JPeriod; kkk++)
        {
         sumopen+=open[bar+kkk];
         sumclose+=close[bar+kkk];
         
         sumlow +=Lowest [Count[kkk]];
         sumhigh+=Highest[Count[kkk]];
        }
      
      Op=sumopen /JPeriod;
      Cl=sumclose/JPeriod; 
      
      Max=MathMax(Op,Cl);
      Min=MathMin(Op,Cl);
      
      if(!(Max-Min)) Max+=_Point;
      

      ClMiddleBuffer[bar]=Max;
      OpMiddleBuffer[bar]=Min;
     
      ColorMiddleBuffer[bar]=0; 
      if(Cl>Op) ColorMiddleBuffer[bar]=2;
      if(Cl<Op) ColorMiddleBuffer[bar]=1;
      
      
      UpperBuffer[bar]=sumhigh/JPeriod;
      LowerBuffer[bar]=sumlow /JPeriod;

      if(bar>0) Recount_ArrayZeroPos(Count);
     }
//----    
   return(rates_total);
  }
//+------------------------------------------------------------------+
